程序師世界是廣大編程愛好者互助、分享、學習的平台,程序師世界有你更精彩!
首頁
編程語言
C語言|JAVA編程
Python編程
網頁編程
ASP編程|PHP編程
JSP編程
數據庫知識
MYSQL數據庫|SqlServer數據庫
Oracle數據庫|DB2數據庫
 程式師世界 >> 編程語言 >> C語言 >> C++ >> C++入門知識 >> hdu2514 Another Eight Puzzle 填數字 搜索水題

hdu2514 Another Eight Puzzle 填數字 搜索水題

編輯:C++入門知識

Another Eight Puzzle
Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 659    Accepted Submission(s): 405

 

Problem Description
Fill the following 8 circles with digits 1~8,with each number exactly once . Conntcted circles cannot be filled with two consecutive numbers.
There are 17 pairs of connected cicles:
A-B , A-C, A-D
B-C, B-E, B-F
C-D, C-E, C-F, C-G
D-F, D-G
E-F, E-H
F-G, F-H
G-H

 

\


 

Filling G with 1 and D with 2 (or G with 2 and D with 1) is illegal since G and D are connected and 1 and 2 are consecutive .However ,filling A with 8 and B with 1 is legal since 8 and 1 are not consecutive .

In this problems,some circles are already filled,your tast is to fill the remaining circles to obtain a solution (if possivle).

 


Input
The first line contains a single integer T(1≤T≤10),the number of test cases. Each test case is a single line containing 8 integers 0~8,the numbers in circle A~H.0 indicates an empty circle.


 


Output
For each test case ,print the case number and the solution in the same format as the input . if there is no solution ,print “No answer”.If there more than one solution,print “Not unique”.

 


Sample Input
3
7 3 1 4 5 8 0 0
7 0 0 0 0 0 0 0
1 0 0 0 0 0 0 0


Sample Output
Case 1: 7 3 1 4 5 8 6 2
Case 2: Not unique
Case 3: No answer


Source
ECJTU 2008 Autumn Contest
 


Recommend
lcy
 

http://acm.hdu.edu.cn/showproblem.php?pid=2514

 

輸入8個數 表示 圖中a b c d e f g h的位置的值只能為1-8的數 然後相鄰的不能是連續的數 即絕對值不能為1  有些數是0 將為0的填成1-8中未使用的數

有多少種方法  如果僅有一種 輸出它   有多種 或沒有  按樣例中那樣輸出 

 

思路 DFS 搜

[cpp] #include<stdio.h>  
#include<math.h>  
#include<string.h>  
int a[10],vis[10],ans[10],anscnt; 
int abs(int q) 

    if(q<0) return -q; 
    return q; 

int ok() 

    if(abs(a[2]-a[1])!=1&& 
        abs(a[3]-a[1])!=1&& 
        abs(a[4]-a[1])!=1&& 
         
        abs(a[2]-a[3])!=1&& 
        abs(a[2]-a[5])!=1&& 
        abs(a[2]-a[6])!=1&& 
         
        abs(a[3]-a[4])!=1&& 
        abs(a[3]-a[5])!=1&& 
        abs(a[3]-a[6])!=1&& 
        abs(a[3]-a[7])!=1&& 
         
        abs(a[4]-a[6])!=1&& 
        abs(a[4]-a[7])!=1&& 
         
        abs(a[5]-a[6])!=1&& 
        abs(a[5]-a[8])!=1&& 
         
        abs(a[6]-a[7])!=1&& 
        abs(a[6]-a[8])!=1&& 
         
        abs(a[7]-a[8])!=1 
        ) 
        return 1; 
    else return 0; 

void DFS(int k) 

    int i,cnt=0; 
    if(k==9) 
//注意這裡是k==9 而不是把讓它等於8之後放在調用函數的最後面 那樣的話 最後一次的賦值就會被還原為0  
        { 
            if(ok()) 
            { 
                anscnt++; 
                if(anscnt==1) 
                { 
                    for(i=1;i<=8;i++) 
                        ans[i]=a[i]; 
                } 
            } 
            return; 
        } 
    if(anscnt>=2) return; 
    if(a[k]!=0) DFS(k+1); 
    else 
        for(i=1;i<=8;i++) 
        { 
            if(!vis[i]) 
            { 
                a[k]=i; 
                vis[i]=1; 
                DFS(k+1); 
                a[k]=0; 
                vis[i]=0; 
            } 
        } 

 
int main() 

    int t,cas=0; 
    scanf("%d",&t); 
    while(t--) 
    { 
        anscnt=0; 
        int i; 
        memset(vis,0,sizeof(vis)); 
        memset(ans,0,sizeof(ans)); 
        scanf("%d %d %d %d %d %d %d %d",&a[1],&a[2],&a[3],&a[4],&a[5],&a[6],&a[7],&a[8]); 
        for(i=1;i<=8;i++) vis[a[i]]=1; 
        DFS(1); 
        printf("Case %d: ",++cas); 
        if(anscnt==1) 
        { 
            for(i=1;i<8;i++)  printf("%d ",ans[i]); 
            printf("%d\n",ans[i]); 
        } 
        else if(anscnt==0) printf("No answer\n"); 
        else printf("Not unique\n"); 
    } 
    return 0; 

  1. 上一頁:
  2. 下一頁:
Copyright © 程式師世界 All Rights Reserved